// Copyright 2016 Tadd Torborg -- I grant the right to modify and sell products using this sourcecode.  
//I insist you put my copyright notice and this line in every sourcecode file included in any project which uses my PWRMAN software. 
// If you do manage to construct or produce 2 or more devices based on this source code, please send an email to me at tadd@mac.com
//  Thanks!! 
// Source code by Tadd Torborg, ham-radio callsign KA2DEW, for PWRMAN power controller -- runs on TI MSP430F2012 CPU.
// Concept by Tadd Torborg.  Board design, layout, stuffed, and maintained by Stephen Snell, ham-radio callsign W4RFQ
// PWRMAN operation is documented on the TARPN web site.  See  http://tarpn.net/pwrman
// I compiled and debugged this project using IAR's EW430 version 5.
extern void           WriteGreenLED(    unsigned char passed_lightGreenButton);
extern void           WriteRedLED(      unsigned char passed_lightRedButton);
extern void           WriteBlueLED(     unsigned char passed_lightBlueBlinky);
extern void           WriteRelayControl(unsigned char passed_turnOnPower);
extern void           WritePiShutdown(  unsigned char passed_shutdownNow);
////// void           WriteAllLeds(     unsigned char passed_blue, unsigned char passed_red, unsigned char passed_green);
extern unsigned short ADC_ReadUnbufferedAtoDPort(unsigned short channel_p,unsigned short reference_p);   // used for reading optical switches, internal temperature and internal CPU voltage,


extern unsigned char ReadPushButtons(void);
extern unsigned char ReadPiPoweredUp(void);
extern unsigned char ReadPiHelloToggle(void);
extern unsigned char ReadMainSupplyAlive(void);
extern unsigned char ReadGelCellHealthy(void);


// P1DIR     CONFIG    0=input, 1=output.
// xxxx xxxx
//         0.......P1.0/A0/TACLK - AtoD input A0  Mains volts sense divided by 7
//        0........P1.1/A1       - AtoD input A1 Button input resistor sense
//       0.........P1.2/A2       - AtoD input A2 Gel Cel volts sense divided by 7
//      1..........P1.3          - P1.3 output  Blue Blinky LED if high
//    1............P1.4          - P1.4 output  Red switch LED if low
//   1.............P1.5          - P1.5 output  Raspberry PI command to shutdown if high
//  0..............P1.6          - P1.6 input  Raspberry PI is running, if high
// 0...............P1.7          - P1.7 input  Raspberry PI hellotoggle every half second

// P2DIR     CONFIG    0=input, 1=output.
// xxxx xxxx
//         0.......P2.0          - nc
//        0........P2.1          - nc
//       0.........P2.2          - nc
//      0..........P2.3          - nc
//    0............P2.4          - nc
//   0.............P2.5          - nc
//  1..............P2.6          - P2.6 output Power Output to the PI if high
// 1...............P2.7          - P2.7 output Green switch LED if low



extern void TurnOffPeripheralsForLowPowerMode(void);
extern void TurnOnPeripherals(void);
extern void ShortDelay(unsigned short passed_delayLength);

